// Copyright 2004, 2005 Edwin Martin <edwin@bitstorm.org>
// This code is triple licensed under MPL/GPL/LGPL. See license.txt for details.

function load() {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("network.http.");
	var inputs = document.getElementsByTagName("textbox");
	for ( var i=0; i<inputs.length; i++ ) {
		if (prefs.getPrefType(inputs[i].id) == prefs.PREF_INT)
			inputs[i].value = prefs.getIntPref(inputs[i].id);
	}
	var inputs = document.getElementsByTagName("checkbox");
	for ( var i=0; i<inputs.length; i++ ) {
		if (prefs.getPrefType(inputs[i].id) == prefs.PREF_BOOL)
			inputs[i].checked = prefs.getBoolPref(inputs[i].id);
	}
}

function saveSettings() {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("network.http.");
	var inputs = document.getElementsByTagName("textbox");
	for ( var i=0; i<inputs.length; i++ ) {
		prefs.setIntPref(inputs[i].id, inputs[i].value);
	}
	var inputs = document.getElementsByTagName("checkbox");
	for ( var i=0; i<inputs.length; i++ ) {
		prefs.setBoolPref(inputs[i].id, inputs[i].checked);
	}
}

function setDefault() {
	var settings = {
		"max-connections": 24,
		"max-connections-per-server": 8,
		"max-persistent-connections-per-server": 2,
		"max-persistent-connections-per-proxy": 4,
		"pipelining": false,
		"proxy.pipelining": false,
		"pipelining.maxrequests": 4
	};
	applySettings( settings );
}

function setPower() {
	var settings = {
		"max-connections": 40,
		"max-connections-per-server": 16,
		"max-persistent-connections-per-server": 16,
		"max-persistent-connections-per-proxy": 16,
		"pipelining": true,
		"proxy.pipelining": true,
		"pipelining.maxrequests": 8
	};
	applySettings( settings );
}

function applySettings( settings ) {
	for ( var i in settings ) {
		switch ( typeof settings[i] ) {
			case "number":
				document.getElementById(i).value = settings[i];
				break;
			case "boolean":
				document.getElementById(i).checked = settings[i];
				break;
		}
	}
}

